//
//  main.m
//  Dictionaries
//
//  Created by Holger Hinzberg on 24.01.12.
//  Copyright (c) 2012 Cocoa-Coding. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Person.h"

int main (int argc, const char * argv[])
{

    @autoreleasepool {
        
        // Einige Personen erzeugen
        Person *dicPer1 = [[Person alloc] init];
        dicPer1.name = @"Meier";
        
        Person *dicPer2 = [[Person alloc] init];
        dicPer2.name = @"Schmidt";
        
        Person *dicPer3 = [[Person alloc] init];
        dicPer3.name = @"Schuster";
        
        // Ein Dictionary erzeugen und die
        // Personen hinzufügen. Jedes Objekt benötigt
        // einen Key, hier NSString, zur Identifizierung.
        NSDictionary *personenDictionary
        = [NSDictionary dictionaryWithObjectsAndKeys:
           dicPer1, @"Meier",
           dicPer2, @"Schmidt",
           dicPer3, @"Schuster",
           nil];
        
        
        // Abfrage einer Person über den Key.
        Person *aDictPerson 
        = [personenDictionary objectForKey:@"Schmidt"];
        
        [aDictPerson sayYourName];
        
        
        
        // Ein Dictionary
        NSMutableDictionary *mutableDict
        = [NSMutableDictionary dictionary];
        
        Person *mDicPer1 = [[Person alloc] init];
        mDicPer1.name = @"Kaufmann";
        [mutableDict setObject:mDicPer1 forKey:@"Kaufmann"];
        
        Person *mDicPer2 = [[Person alloc] init];
        mDicPer2.name = @"Kellner";
        [mutableDict setObject:mDicPer2 forKey:@"Kellner"];
        
        Person *mDicPer3 = [[Person alloc] init];
        mDicPer3.name = @"Krämer";
        
        // Objekt Krämer ersetzt Kaufmann durch Verwendung
        // des passenden Schlüssels.
        [mutableDict setObject:mDicPer3 forKey:@"Kaufmann"];
        
        
        
        
        
        
    }
    return 0;
}

